'use strict';

define([
	'app',
], function(app) {

	app.controller('accountsSelection',
		["$uibModalInstance", "$uibModal", "$scope", "$timeout", "jetapi", "meta", "accounts", "callParams",
			function($uibModalInstance, $uibModal, $scope, $timeout, jetapi, meta, accounts, callParams) {

				$scope.loading = false;
				$scope.accounts = [];


				var handleAccounts = function(response) {
					console.log(response);
					if(!response.success) {
						$scope.error = "Error: Unable to fetch account list.";
						$scope.loading = false;
						return;
					}
					for (var i = 0; i < response.data.accounts.length; i++) {
						response.data.accounts[i].checked = accounts !== undefined && accounts.length ? accounts.indexOf(response.data.accounts[i].username) >= 0 : false;
					}
					$scope.accounts = response.data.accounts;
					$scope.loading = false;
				};

				$scope.fetchAccounts = function () {
					$scope.loading = true;

					if(callParams) {
						jetapi.listAccountsByBackupFilters(callParams, function (response) {
							handleAccounts(response);
						});
					}
					else {
						jetapi.listAccounts({ sort: { username: 1 } }, function (response) {
							handleAccounts(response);
						});
					}

				};

				$timeout($scope.fetchAccounts);

				$scope.ok = function () {

					var selected = [];
					for (var i = 0; i < $scope.accounts.length; i++) {
						if($scope.accounts[i].checked) selected.push($scope.accounts[i].username);
					}
					$uibModalInstance.close( selected );
				};

				$scope.cancel = function () {
					$uibModalInstance.dismiss($scope.LANG.t('cancel'));
				};
			}
		]
	);
});