'use strict';

define([
	'app',
	], function(app) {

	app.controller('cloneSelection',
		["$uibModalInstance", "$uibModal", "$scope", "$timeout", "jetapi", "meta", "account",
			function($uibModalInstance, $uibModal, $scope, $timeout, jetapi, meta, account) {

				$scope.account = account;

				$scope.selected = {
					backup: '',
					destination: '',
					flag: 1
				};

				$scope.flags = [
					{_id: 1, name: $scope.LANG.t('Restore the account with shared IP') },
					{_id: 2, name: $scope.LANG.t('Try to match dedicated IP status (Only if possible)') }
				];
				$scope.backups = [{_id: '', display: $scope.LANG.t('- Live Account -') }];
				$scope.destinations = [{ _id: '', name: $scope.LANG.t('- Select Destination -') }];

				$scope.fetchBackups = function () {
					if(!account) return;
					jetapi.listBackups({ find: { account: account.username }, type: 127 }, function (response) {
						for(var i = 0; i < response.data.backups.length; i++) {
							response.data.backups[i].display = $scope.LANG.t("Backup: %s", $scope.LANG.d(response.data.backups[i].created, 'longtime'));
							$scope.backups.push(response.data.backups[i]);
						}
					});
				};

				$scope.fetchDestinations = function () {
					jetapi.listDestinations({}, function (response) {
						for(var i = 0; i < response.data.destinations.length; i++) {
							if(!response.data.destinations[i].clone_destination) continue;
							$scope.destinations.push(response.data.destinations[i]);
						}
					});
				};

				$timeout($scope.fetchBackups());
				$timeout($scope.fetchDestinations());

				$scope.ok = function () {
					$uibModalInstance.close( $scope.selected );
				};

				$scope.cancel = function () {
					$uibModalInstance.dismiss($scope.LANG.t('cancel'));
				};
			}
		]
	);
});