'use strict';

define([
	'app',
	], function(app) {
	app.controller("disasterRecoveryAccounts",
		["$rootScope", "$scope", "$routeParams", "$location", "$timeout", "jetapi", "meta", "utils", "SweetAlert",
			function ($rootScope, $scope, $routeParams, $location, $timeout, jetapi, meta, utils, SweetAlert) {


				$scope.disasterRecovery = true;
				$scope.models.structure = 0;

				$scope.checkall = false;
				$scope.allPagesAccountsChecked = false;

				$scope.setCheckAllPage = function() {
					if(!$scope.checkall) $scope.allPagesAccountsChecked = false;
					for (var i=0; i < $scope.accounts.length; i++) $scope.accounts[i].checked = $scope.checkall;
				};

				$scope.checkInAllPages = function(){
					$scope.allPagesAccountsChecked = true;
				};

				$scope.getChecked = function() {
					var checkedAccounts = [];
					for(var i=0; i<$scope.accounts.length; i++) if($scope.accounts[i].checked) checkedAccounts.push($scope.accounts[i]);
					return checkedAccounts;
				};

				$scope.clearSelection = function() {
					for (var i=0; i < $scope.accounts.length; i++) $scope.accounts[i].checked = false;
					$scope.allPagesAccountsChecked = false;
					$scope.checkall = false;
				};

				$scope.restoreSelected = function() {

					if($scope.allPagesAccountsChecked) {
						var params =
						jetapi.listAccountsBackups({type:127, dr_mode: $scope.disasterRecovery
						}, function (response) {
							if(response.success) accountsRestorePart(response.data.accounts);
						});
					}

					else accountsRestorePart($scope.getChecked());
				};

				var accountsRestorePart = function(accounts) {

					var ids = [];
					for(var i=0; i< accounts.length; i++) {

						if(!accounts[i].backup) continue;
						$scope.selectedAccount = accounts[i];

						ids.push(accounts[i].backup._id);
					}
					jetapi.addQueueRestore({ _id: ids }, function(response) {
						// if(!response.success) SweetAlert.error($scope.LANG.t("Error!"), $scope.LANG.t("Failed to add accounts to the restore queue."));
					});
					$scope.clearSelection();
				};



				$scope.$on('nextStep', function() {

					var total = 0;
					var accounts = $scope.getChecked();
					for(var i=0; i<accounts.length; i++) if($scope.accounts[i].backup) total++;

					if(!total) {
						SweetAlert.error($scope.LANG.t("Error!"), $scope.LANG.t("Please select at least one account to restore"));
						return;
					}

					$scope.restoreSelected();

					delete sessionStorage.disasterRecovery;
					jetapi.exitDisasterRecovery();

					SweetAlert.info($scope.LANG.t("Information!"), $scope.LANG.t("The selected accounts is been added to the restore queue. This process can take some time, once all accounts will be added to the queue you will be automatically passed to the queue page."));
					$scope.$emit("commitNextStep", {});
				});
			}
		]
	);
});