'use strict';

define([
	'app',
	], function(app) {
	app.controller("filePermissionManage",
		["$rootScope", "$scope", "$routeParams", "$location", "$timeout", "$uibModal", "$q", "jetapi", "meta", "utils", "SweetAlert",
			function ($rootScope, $scope, $routeParams, $location, $timeout, $uibModal, $q, jetapi, meta, utils, SweetAlert) {
				$rootScope.$emit('menuItem', 'Settings');

				$scope.details = {};
				$scope.saveData = {
					regex: '',
					owner: '',
					group: '',
					permissions: ''
				};

				$scope.saveing = false;
				$scope.status = undefined;
				$scope.changed = false;

				$scope.$watch("saveData", function(){
					$scope.changed = utils.isChanged($scope.saveData, $scope.details, ['_id']);
				}, true);

				$scope.saveChanges = function(apply) {

					if($scope.saveing) return;

					$scope.status = undefined;
					$scope.saveing = true;

					var apiParams = utils.saveParams($scope.saveData, $scope.details);

					apiParams.action = $scope.details._id ? 'modify' : 'create';

					jetapi.manageFilePermission(apiParams, function(response) {

						$scope.saveing = false;

						if(response.success)
						{
							$scope.changed = false;
							$scope.saveData._id = response.data._id;
							$scope.details = utils.duplicateObject($scope.saveData);
							if(apply) $location.path('/filePermissionManage/' + response.data._id);
							else $location.path('/filePermissions');
							SweetAlert.swal($scope.LANG.t("Success!"), response.message, "success");
						}
						else
						{
							$scope.status = {
								message: response.message,
								type: response.success ? "success" : "danger",
								closeable: false,
								ttl: 10000
							};
						}
					});
				};

				$scope.fetch = function(permission_id) {
					jetapi.getFilePermission({ '_id': permission_id }, function(response) {
						$scope.details = response.data;
						$scope.saveData = utils.duplicateObject($scope.details);
					});

				};

				var permission_id = $routeParams.id;
				if(permission_id) $timeout($scope.fetch(permission_id));
			}
		]
	);

});