'use strict';

define([
	'app',
	], function(app) {

	app.controller('resellersSelection',
		["$uibModalInstance", "$uibModal", "$scope", "$timeout", "jetapi", "meta", "accounts",
			function($uibModalInstance, $uibModal, $scope, $timeout, jetapi, meta, accounts) {

				$scope.loading = false;
				$scope.accounts = [];

				$scope.fetchAccounts = function () {

					$scope.loading = true;

					jetapi.listAccounts({}, function (response) {

						for (var i = 0; i < response.data.accounts.length; i++) {
							if(!response.data.accounts[i].reseller) continue;
							response.data.accounts[i].checked = accounts !== undefined && accounts.length ? accounts.indexOf(response.data.accounts[i].username) >= 0 : false;
							$scope.accounts.push(response.data.accounts[i]);
						}

						$scope.loading = false;

					});
				};

				$timeout($scope.fetchAccounts);

				$scope.ok = function () {

					var selected = [];
					for (var i = 0; i < $scope.accounts.length; i++) {
						if($scope.accounts[i].checked) selected.push($scope.accounts[i].username);
					}
					$uibModalInstance.close( selected );
				};

				$scope.cancel = function () {
					$uibModalInstance.dismiss($scope.LANG.t('cancel'));
				};
			}
		]
	);
});