'use strict';

define([
	'app',
	], function(app) {
	app.controller("scheduleManage",
		["$rootScope", "$scope", "$routeParams", "$location", "$timeout", "jetapi", "meta", "utils", "SweetAlert",
			function ($rootScope, $scope, $routeParams, $location, $timeout, jetapi, meta, utils, SweetAlert) {
				//$rootScope.$emit('menuItem', 'Schedules');

				//$scope.model = model;

				//$scope.dismiss = function () {
				//	alert('TEST');
					//uibinstance.dismiss();
				//};

				$scope.saveData = {};
				$scope.details = {
					name: '',
					type: 1,
					typedata: '',
					//time: '01:00 AM',
					delaytype: 'minutes',
					delayamount: 0
				};

				$scope.saveing = false;

				$scope.status = undefined;
				$scope.changed = false;
				$scope.cancelled = false;

				$scope.types = [
					//{ label: $scope.LANG.t('Manually'), value: 8 },
					{ label: $scope.LANG.t('Hourly'), value: 1 },
					{ label: $scope.LANG.t('Daily'), value: 2 },
					{ label: $scope.LANG.t('Weekly'), value: 3 },
					{ label: $scope.LANG.t('Monthly'), value: 4 },
					{ label: $scope.LANG.t('After Backup Job Done'), value: 5 },
					{ label: $scope.LANG.t('After Clone Job Done'), value: 6 },
					{ label: $scope.LANG.t('After cPanel Backup Done'), value: 7 }
				];

				$scope.hours = [
					{ label: $scope.LANG.t('Every Hour'), value: 1 },
					{ label: $scope.LANG.t('Every 2 Hours'), value: 2 },
					{ label: $scope.LANG.t('Every 3 Hours'), value: 3 },
					{ label: $scope.LANG.t('Every 4 Hours'), value: 4 },
					{ label: $scope.LANG.t('Every 6 Hours'), value: 6 },
					{ label: $scope.LANG.t('Every 8 Hours'), value: 8 },
					{ label: $scope.LANG.t('Every 12 Hours'), value: 12 }
				];

				$scope.days = [
					{ label: $scope.LANG.t('Sunday'), value: 1 },
					{ label: $scope.LANG.t('Monday'), value: 2 },
					{ label: $scope.LANG.t('Tuesday'), value: 3 },
					{ label: $scope.LANG.t('Wednesday'), value: 4 },
					{ label: $scope.LANG.t('Thursday'), value: 5 },
					{ label: $scope.LANG.t('Friday'), value: 6 },
					{ label: $scope.LANG.t('Saturday'), value: 7 }
				];

				$scope.months = [
					{ label: $scope.LANG.t('%sst of the month', 1), value: 1 },
					{ label: $scope.LANG.t('%sth of the month', 7), value: 7 },
					{ label: $scope.LANG.t('%sth of the month', 14), value: 14 },
					{ label: $scope.LANG.t('%sst of the month', 21), value: 21 },
					{ label: $scope.LANG.t('%sth of the month', 28), value: 28 }
				];

				$scope.delay_types = [
					{ label: $scope.LANG.t('Minutes'), value: 'minutes' },
					{ label: $scope.LANG.t('Hours'), value: 'hours' },
					{ label: $scope.LANG.t('Days'), value: 'days' }
				];

				$scope.backups = [ { _id: '', name: $scope.LANG.t("- Select Backup Job -") } ];
				$scope.clones = [ { _id: '', name: $scope.LANG.t("- Select Clone Job -") } ];

				$scope.toggleTypeData = function(value) {
					var idx = $scope.saveData.typedata.indexOf(value);
					if (idx > -1) $scope.saveData.typedata.splice(idx, 1);
					else $scope.saveData.typedata.push(value);
				};

				$scope.loadScheduleType = function(type, defaults) {

					if($scope.saveData !== undefined) var name = $scope.saveData.name;
					$scope.saveData = utils.duplicateObject($scope.details);
					if(name !== undefined) $scope.saveData.name = name;

					if(typeof $scope.details.typedata === 'object')
					{
						$scope.saveData.typedata = [];
						for(var i = 0; i < $scope.details.typedata.length; i++) $scope.saveData.typedata.push($scope.details.typedata[i]);
					}

					$scope.saveData.type = type;

					var mongoIdPattern = new RegExp("^[a-f0-9]{24}$", 'g');

					switch(type)
					{
						case 1:
							if(defaults) $scope.saveData.typedata = 1;
						break;

						case 2:
						case 4:
							if(defaults) $scope.saveData.typedata = [];
						break;

						case 3:
							if(defaults) $scope.saveData.typedata = 1;
						break;

						case 5:
							if(
								$scope.saveData.typedata === undefined ||
								typeof $scope.saveData.typedata !== 'string' ||
								!mongoIdPattern.test($scope.saveData.typedata.trim())
							) $scope.saveData.typedata = '';

							jetapi.listBackupJobs({}, function(response) {
								for(var i = 0; i < response.data.jobs.length; i++) {
									if($scope.excludeids && $scope.excludeids.indexOf(response.data.jobs[i]._id) >=0) continue;
									$scope.backups.push({
										_id: response.data.jobs[i]._id,
										name: response.data.jobs[i].name
									});
								}
							});
						break;

						case 6:
							if(
								$scope.saveData.typedata === undefined ||
								typeof $scope.saveData.typedata !== 'string' ||
								!mongoIdPattern.test($scope.saveData.typedata.trim())
							) $scope.saveData.typedata = '';

							jetapi.listCloneJobs({}, function(response) {
								for(var i = 0; i < response.data.jobs.length; i++)
								{
									$scope.clones.push({
										_id: response.data.jobs[i]._id,
										name: response.data.jobs[i].name
									});
								}
							});
						break;
					}
				};

				$scope.fetchScheduleData = function(schedule_id) {

					jetapi.getSchedule({ '_id': schedule_id }, function(response) {
						$scope.details = response.data;
						//$scope.details.time = $scope.details.time_parsed;
						$scope.loadScheduleType($scope.details.type);
					});

				};

				$scope.$watch("saveData", function(){
					$scope.changed = utils.isChanged($scope.saveData, $scope.details, ['_id','checked']);
				}, true);

				/*
				$scope.parseTime = function (time) {
					var matches = /^([0-9]+):([0-9]+)\s+(AM+|PM+)$/g.exec(time);
					if(!matches) return 0;
					var output = parseInt(matches[1] + matches[2]);
					if(output >= 1200) output -= 1200;
					if(matches[3] === 'PM') output += 1200;
					return output;
				};
				*/

				$scope.$on('createSchedule', function (event) {
					$scope.saveChanges(true, function(response) {
						$scope.$emit('scheduleResponse', response);
					});
				});

				/*
				$scope.$on('$destroy', function() {
					if($scope.changed && !$scope.cancelled)
					{
						SweetAlert.swal({
							title: $scope.LANG.t("Are you sure?"),
							text: $scope.LANG.t("You didn't saved your changes"),
							icon: "warning",
							buttons: [$scope.LANG.t("Disregard Changes"), $scope.LANG.t("Save")]
						}, function(isConfirm){
							if (isConfirm) {
								$scope.saveChanges();
							}
						});
					}
				});
				*/

				$scope.cancel = function() {
					$scope.cancelled = true;
					$location.path('/schedules');
				};

				$scope.saveChanges = function(apply, callback) {

					if($scope.saveing) return;

					$scope.status = undefined;
					$scope.saveing = true;

					var apiParams = utils.saveParams($scope.saveData, $scope.details, [], function (key) {
						if(key === 'type') return true;

						// More validations

						return false;
					});

					//if([2,3,4].indexOf(apiParams.type) >= 0 && typeof apiParams.time === 'string') apiParams.time = $scope.parseTime(apiParams.time);
					apiParams.action = $scope.details._id ? 'modify' : 'create';

					jetapi.manageSchedule(apiParams, function(response) {

						$scope.saveing = false;

						if(callback !== undefined) {
							callback(response);
							return;
						}

						if(response.success)
						{
							$scope.changed = false;
							$scope.saveData._id = response.data._id;
							$scope.details = utils.duplicateObject($scope.saveData);
							if(apply) $location.path('/scheduleManage/' + response.data._id);
							else $location.path('/schedules');
							SweetAlert.swal($scope.LANG.t("Success!"), response.message, "success");
						}
						else
						{
							$scope.status = {
								message: response.message,
								type: "danger",
								closeable: false,
								ttl: 10000
							};
						}
					});
				};

				var schedule_id = $routeParams.id;

				if(schedule_id) $timeout($scope.fetchScheduleData(schedule_id));
				else $scope.loadScheduleType($scope.details.type, true);
	}]);
});