'use strict';

define([
	'app',
], function(app) {
	app.controller("performanceSettings",
		["$rootScope", "$scope", "jetapi",
			function ($rootScope, $scope, jetapi) {


				$scope.queuePriorities = [
					{ _id: '', name: $scope.LANG.t('Default') }
				];

				$scope.fetchQueuePriorities = function() {
					jetapi.listQueuePriorities({}, function (response) {
						var priorities = response.data.priorities;
						for(var i=0; i< priorities.length; i++ ){
							$scope.queuePriorities.push({ _id: priorities[i]._id, name: priorities[i].name });
						}
					});
				};
				$scope.fetchQueuePriorities();


				$scope.mysqlpackets_options = [
					{ label: $scope.LANG.t("Default"), value: 0 },
					{ label: "32 MB", value: 32 },
					{ label: "64 MB", value: 64 },
					{ label: "128 MB", value: 128 },
					{ label: "256 MB", value: 256 },
					{ label: "512 MB", value: 512 },
					{ label: "1 GB", value: 1024 }
				];

				$scope.concurrent_queued_rates = [
					{ label: $scope.LANG.t("Unlimited"), value: 0 },
					{ label: 1, value: 1 },
					{ label: 2, value: 2 },
					{ label: 3, value: 3 },
					{ label: 4, value: 4 },
					{ label: 5, value: 5 }
				];

				$scope.concurrent_scheduled_rates = [
					{ label: $scope.LANG.t("Unlimited"), value: 0 },
					{ label: 1, value: 1 },
					{ label: 2, value: 2 },
					{ label: 3, value: 3 },
					{ label: 4, value: 4 },
					{ label: 5, value: 5 }
				];

				$scope.max_load_rates = [
					{ label: $scope.LANG.t("Disabled"), value: 0 },
					{ label: 1, value: 1 },
					{ label: 2, value: 2 },
					{ label: 3, value: 3 },
					{ label: 4, value: 4 },
					{ label: 5, value: 5 },
					{ label: 10, value: 10 },
					{ label: 15, value: 15 }
				];

				$scope.restore_sleep_rates = [
					{ label: $scope.LANG.t("Disabled"), value: 0 },
					{ label: 15, value: 15 },
					{ label: 30, value: 30 },
					{ label: 45, value: 45 },
					{ label: 60, value: 60 }
				];

				$scope.account_download_limit_rates = [
					{ label: $scope.LANG.t("Unlimited"), value: 0 },
					{ label: 1, value: 1 },
					{ label: 2, value: 2 },
					{ label: 3, value: 3 },
					{ label: 4, value: 4 },
					{ label: 5, value: 5 }
				];

				$scope.downloads_delete_ttl_rates =[
					{ label: $scope.LANG.t("Disabled"), value: 0 },
					{ label: 1, value: 1 },
					{ label: 2, value: 2 },
					{ label: 3, value: 3 },
					{ label: 7, value: 7 },
					{ label: 14, value: 14 },
					{ label: 30, value: 30 },
				];



			}]);
});