'use strict';

define([
	'app',
], function (app) {
	app.directive("tooltip", ["$sce", "$compile", "lang",
		function($sce, $compile, lang) {

			return {
				restrict: "A",
				replace: false,
				terminal: true,
				priority: 1000,
				link: function (scope,element, attrs) {

					var content = attrs.tooltip;
					var regex = /^(top|top-left|top-right|bottom|bottom-left|bottom-right|left|left-top|left-bottom|right|right-top|right-bottom)\|(.*)$/;

					if(regex.test(content)) {
						var parts = content.match(regex);
						element.attr('tooltip-placement', parts[1]);
						content = parts[2];
					}

					regex = /^\{\{(.*)\}\}$/;

					if(regex.test(content)) {
						parts = content.match(regex);
						parts = parts[1].split('.');

						content = scope;
						for(var i = 0; i < parts.length; i++) if(content !== undefined) content = content[parts[i]];
					}

					element.removeAttr("tooltip");

					if(!content) {
						$compile(element)(scope);
						return;
					}

					if(scope.contentHTML === undefined) scope.contentHTML = [];
					var index = scope.contentHTML.length;
					scope.contentHTML[index] = $sce.trustAsHtml("<div style='padding: 5px;'>" + lang.t(content) + "</div>");
					element.attr('uib-tooltip-html', "contentHTML[" + index + "]");
					$compile(element)(scope);
				}
			};
		}
	]);
});