'use strict';

define([], function() {
	var UTILS = function() {};

	UTILS.prototype = {
		sizeToHumanReadable: function(bytes, si, decimals) {
			return (this.sizeToNumber(bytes, si, decimals) + " " + this.sizeToType(bytes, si)).trim();
		},
		sizeToNumber: function(bytes, si, decimals) {
			if(si === undefined) si = false;
			if(decimals === undefined) decimals = 2;
			var unit = si ? 1000 : 1024;
			if (bytes < unit) return bytes;
			var exp = parseInt(Math.log(bytes)/Math.log(unit));
			return (bytes/Math.pow(unit, exp)).toFixed(decimals);
		},
		sizeToType: function(bytes, si) {
			if(si === undefined) si = false;
			var unit = si ? 1000 : 1024;
			if (bytes < unit) return "B";
			var exp = parseInt(Math.log(bytes)/Math.log(unit));
			var pre = (si ? "kMGTPE" : "KMGTPE");
			return pre[exp-1] + "B";
		},
		countObj: function (obj) {
			var count = 0;
			for(var key in obj) count++;
			return count;
		}
	};

	return new UTILS();
});