'use strict';

define(['app'], function (app) {
	app.factory('loader', ["$http", "cfpLoadingBar", function($http, cfpLoadingBar) {
		return {
			_timeout: 200,
			_scope: null,
			_loading: false,
			_loadingTimeout: null,
			_isLoadingApp: function () {
				return $http.pendingRequests.length > 0;
			},
			_clearTimeout: function() {
				if(this._loadingTimeout === null) return;
				clearTimeout(this._loadingTimeout);
				this._loadingTimeout = null;
			},
			_routeChange: function() {
				var self = this;
				this._scope.$on('$routeChangeStart', function() {
					cfpLoadingBar.start();
					self._loadingApp = true;
				});
			},
			_watch: function() {
				var self = this;
				this._scope.$watch(self._isLoadingApp, function(v) {
					if(!v) self._complete();
					else self._clearTimeout();
				});
			},
			_complete: function() {
				var self = this;
				if(!self._loadingApp) return;
				self._loadingTimeout = setTimeout(function() {
					cfpLoadingBar.complete();
					self._loadingApp = false;
					self._loadingTimeout = null;
				}, self._timeout);
			},
			setScope: function(scope) {
				this._scope = scope;
			},
			setTimeout: function(timeout) {
				this._timeout = timeout;
			},
			init: function ($scope) {
				if($scope !== undefined) this.setScope($scope);
				this._routeChange();
				this._watch();
			}
		};
	}]);
});