'use strict';

define([],
	function() {
		return angular.module("JetBackupApp", [
			"ngRoute",
			"ngAnimate",
			"ngSanitize",
			"ui.bootstrap",
			"jm.i18next"
		])
		.config(["$animateProvider", "$routeProvider", function($animateProvider, $routeProvider) {
			$animateProvider.classNameFilter(/(action-module|disappearing-table-row)/);

			var mustAgree = ["$location", function($location) {
				var gdpr = window.PAGE.info.gdpr;

				if(gdpr.enabled && !gdpr.termsagreed && $location.path() != '/gdpr') {
					$location.path('/gdpr');
				}
			}];

			$routeProvider
			.when("/", { templateUrl: "app/views/index.ptt", resolve: { mess: mustAgree } })
			.when("/fullBackups", { templateUrl: "app/views/fullBackups.ptt", resolve: { mess: mustAgree } })
			.when("/dbBackups", { templateUrl: "app/views/dbBackups.ptt", resolve: { mess: mustAgree } })
			.when("/fileBackups", { templateUrl: "app/views/fileBackups.ptt", resolve: { mess: mustAgree } })
			.when("/fileManager/:id", { templateUrl: "app/views/fileManager.ptt", resolve: { mess: mustAgree } })
			.when("/settings", { templateUrl: "app/views/settings.ptt", resolve: { mess: mustAgree } })
			.when("/gdpr", { templateUrl: "app/views/gdpr.ptt", resolve: { mess: mustAgree } })
			.when("/snapshots", { templateUrl: "app/views/snapshots.ptt", resolve: { mess: mustAgree } })
			//.when("/sslBackups", { templateUrl: "app/views/sslBackups.ptt", resolve: { mess: mustAgree } }) See issue #722
			.when("/dnsBackups", { templateUrl: "app/views/dnsBackups.ptt", resolve: { mess: mustAgree } })
			.when("/emailBackups", { templateUrl: "app/views/emailBackups.ptt", resolve: { mess: mustAgree } })
			.when("/cronBackups", { templateUrl: "app/views/cronBackups.ptt", resolve: { mess: mustAgree } })
			.when("/queues", { templateUrl: "app/views/queues.ptt", resolve: { mess: mustAgree } })

		}]).controller("baseController",
			["$rootScope", "$scope", "$location", "lang", "consts", "utils", function($rootScope, $scope, $location, lang, consts, utils) {

			// console.log(PAGE.direction, window.PAGE.direction);
				$rootScope.LANG = lang;
				$rootScope.CONSTS = consts;
				$rootScope.isRTL = PAGE.direction == 'rtl';
				$scope.PERMS = PAGE.permissions;
				$scope.UTILS = utils;


				$scope.changeView = function (view) {
					$location.path(view);
				};

			}]).animation(".action-module", ["$animateCss", function($animateCss) {
			return {
				enter: function(elem, done) {
					var height = elem[0].offsetHeight;
					return $animateCss(elem, {
						from: { height: "0" },
						to: { height: height + "px" },
						duration: 0.3,
						easing: "ease-out",
						event: "enter",
						structural: true
					})
					.start()
					.done(function() {
						elem[0].style.height = "";
						done();
					});
				},
				leave: function(elem, done) {
					var height = elem[0].offsetHeight;
					return $animateCss(elem, {
						event: "leave",
						structural: true,
						from: { height: height + "px" },
						to: { height: "0" },
						duration: 0.3,
						easing: "ease-out"
					})
					.start()
					.done(function() {
						done();
					});
				}
			};
		}])
		// This 2 lines is a patch for cPanel old versions issue
		.controller("applicationListController", function () {})
		.controller("sidebarController", function () {});
	}
);
