'use strict';

define([
		'app'
	], function (app) {
		app.controller('cronBackups',
			['$scope', '$interval', '$routeParams', 'meta', 'lang', 'backup', 'jetapi', 'consts', '$timeout',
				function ($scope, $interval, $routeParams, meta, lang, backup, jetapi, consts, $timeout) {

					$scope.backupType = consts.BACKUP_TYPE_CRON_JOBS;

					$scope.backups = [];
					$scope.loading = false;
					$scope.actionModule= '';
					$scope.config = PAGE.config;
					$scope.refreshIntervalRate = 3000;
					$scope.interval = null;

					var metaCronBackups = meta.new('cronBackups');
					$scope.meta = metaCronBackups;
					$scope.metaData = metaCronBackups.getData();

					metaCronBackups.setSortReverse(false);
					if(!metaCronBackups.getSortBy()) metaCronBackups.setSortBy("created");
					if(!metaCronBackups.getSortDirection()) metaCronBackups.setSortDirection("asc");
					metaCronBackups.setSortFields(["created", "size", "location"]);
					metaCronBackups.setTotalItems($scope.backups.length);

					$scope.backupHandler = new backup($scope.backupType, metaCronBackups);


					$scope.fetchData = function() {

						$scope.loading = true;

						$scope.backups = [];
						$scope.backupHandler.loadList(function(response) {

							metaCronBackups.setTotalItems(response.data.total);
							metaCronBackups.calculate(response.data.backups);
							$scope.backups = response.data.backups;
							$scope.loading = false;

							$scope.backupHandler.checkStatus($scope);
							$scope.backupHandler.setList($scope.backups);
						});
					};

					$scope.checkStatus = function () {
						if(!$scope.backupHandler.hasQueueItem) return;
						$scope.interval = $interval(function() {
							if(!$scope.backupHandler.hasQueueItem()){
								$interval.cancel($scope.interval);
								$scope.interval = null;
								return;
							}
							$scope.backupHandler.checkStatus($scope);
						}, $scope.refreshIntervalRate);
					};

					$timeout(function () {
						$scope.fetchData();
						$scope.checkStatus();
					}());

					$scope.$on("$destroy", function() {
						if($scope.interval !== undefined) {
							$interval.cancel($scope.interval);
							$scope.interval = null;
						}
					});
				}
			]
		);
	}
);