'use strict';

define([
		'app'
	], function (app) {
		app.controller('fileBackups',
			['$scope', '$interval', '$routeParams', 'meta', 'lang', 'backup', 'jetapi', 'consts',
				function ($scope, $interval, $routeParams, meta, lang, backup, jetapi, consts) {

					$scope.backupType = consts.BACKUP_TYPE_FILES;

					$scope.backups = [];
					$scope.loading = false;
					$scope.config = PAGE.config;

					var metaFileBackup = meta.new('fileBackups');
					$scope.meta = metaFileBackup;
					$scope.metaData = metaFileBackup.getData();

					metaFileBackup.setSortReverse(false);
					if(!metaFileBackup.getSortBy()) metaFileBackup.setSortBy("created");
					if(!metaFileBackup.getSortDirection()) metaFileBackup.setSortDirection("asc");
					metaFileBackup.setSortFields(["created", "size", "location"]);
					metaFileBackup.setTotalItems($scope.backups.length);

					$scope.backupHandler = new backup($scope.backupType, metaFileBackup);


					$scope.fetchData = function() {
						$scope.loading = true;
						$scope.backups = [];

						$scope.backupHandler.loadList(function(response) {

							metaFileBackup.setTotalItems(response.data.total);
							metaFileBackup.calculate(response.data.backups);
							$scope.backups = response.data.backups;
							$scope.loading = false;

							$scope.backupHandler.setList($scope.backups);
						});
					};

					$scope.fetchData();
				}
			]
		);
	}
);