'use strict';

define([
		'app'
	], function (app) {
		app.controller('fullBackups',
			['$scope', '$interval', '$routeParams', 'meta', 'lang', 'backup', 'jetapi', 'consts', '$timeout',
				function ($scope, $interval, $routeParams, meta, lang, backup, jetapi, consts, $timeout) {

					$scope.backupType = consts.BACKUP_TYPE_FULL;

					$scope.backups = [];
					$scope.loading = false;
					$scope.actionModule= '';
					$scope.config = PAGE.config;
					$scope.refreshIntervalRate = 3000;
					$scope.interval = null;

					var metaFullBackups = meta.new('fullBackups');
					$scope.meta = metaFullBackups;
					$scope.metaData = metaFullBackups.getData();

					metaFullBackups.setSortReverse(false);
					if(!metaFullBackups.getSortBy()) metaFullBackups.setSortBy("created");
					if(!metaFullBackups.getSortDirection()) metaFullBackups.setSortDirection("asc");
					metaFullBackups.setSortFields(["type", "created", "size", "flag_name", "destination"]);
					metaFullBackups.setTotalItems($scope.backups.length);

					$scope.backupHandler = new backup($scope.backupType, metaFullBackups);

					$scope.fetchData = function() {
						$scope.loading = true;
						$scope.backups = [];
						$scope.backupHandler.loadList(function(response) {

							metaFullBackups.setTotalItems(response.data.total);
							metaFullBackups.calculate(response.data.backups);
							$scope.backups = response.data.backups;
							$scope.loading = false;

							$scope.backupHandler.checkStatus($scope);
							$scope.backupHandler.setList($scope.backups);
						});
					};

					$scope.checkStatus = function () {
						if(!$scope.backupHandler.hasQueueItem) return;
						$scope.interval = $interval(function() {
							if(!$scope.backupHandler.hasQueueItem()){
								$interval.cancel($scope.interval);
								$scope.interval = null;
								return;
							}
							$scope.backupHandler.checkStatus($scope);
						}, $scope.refreshIntervalRate);
					};

					$timeout(function () {
						$scope.fetchData();
						$scope.checkStatus();
					}());

					$scope.$on("$destroy", function() {
						if($scope.interval !== undefined) {
							$interval.cancel($scope.interval);
							$scope.interval = null;
						}
					});
				}
			]
		);
	}
);